
#ifndef SHM_MEMORY_TOOL_H

#define SHM_MEMORY_TOOL_H

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>

#include <vdr/tools.h>

class PointerShmFdListObject : public cListObject {
        private:
                int shmfd;
		char * name;
		void * ptr;
		size_t sz;

        public:
                // PointerShmFdListObject() { shmfd=-1; ptr=NULL; }

                PointerShmFdListObject( const PointerShmFdListObject & v ) 
		{ shmfd=v.shmfd; ptr=v.ptr; sz=v.sz; name = strdup(v.name); }

                PointerShmFdListObject( int fd, const char * fname,
					void * memptr, size_t size ) 
		{ shmfd=fd; ptr=memptr; name = strdup(fname); sz=size; }

		~PointerShmFdListObject()
		{ free(name); }

                void*        getPtr()  const { return ptr; }
                size_t       getSize() const { return sz; }
                int          getFd()   const { return shmfd; }
		const char * getFileName() const { return name; }

                virtual bool operator==(const cListObject & ListObject ) const
                { return ( ptr   == ((PointerShmFdListObject *)&ListObject)->ptr) &&
			 ( shmfd == ((PointerShmFdListObject *)&ListObject)->shmfd) ;
		}

                virtual bool operator<(const cListObject & ListObject ) 
                { return ( shmfd < ((PointerShmFdListObject *)&ListObject)->shmfd)
			 ;
		}

                virtual bool operator>(const cListObject & ListObject ) const
                { return ( shmfd > ((PointerShmFdListObject *)&ListObject)->shmfd)
			 ;
		}

                operator int    () const { return shmfd; }
                operator void * () const { return ptr; }
};

void * shm_malloc (size_t size);
void   shm_free   (void * memptr);

PointerShmFdListObject  * shm_find   (void * memptr);

#endif

